/*

    File: Main.cpp

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#include <stdio.h>
#include <math.h>

#include "../m_system3d/error.h"
#include "../m_system3d/main.h"

#include "../m_foundation/texture.h"
#include "../m_foundation/main.h"

#include "../m_cdplayer/cdplayer.h"

// ***************** initial button stats ***************** 

M_CDPlayer *cdPlayer = NULL;

bool Init_Application3D(void)
{
	main_console->SetIdleVisible(false);

	VectorSet(&main_camera->position, 0,0,0);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	main_cdaudio->PlayMode(true);

//if we are going to do ortho...
	main_camera->ortho = true;
	main_camera->halfWidth = 11;

	cdPlayer = new M_CDPlayer();
	if (cdPlayer && !cdPlayer->Init())
	{
		delete cdPlayer;
		cdPlayer = NULL;
	}
	if (!cdPlayer) return false;

	QuatSet(&cdPlayer->angle, -.369649f, 0.792646f, -0.467502f, 0.128507f);
	VectorSet(&cdPlayer->position, 150,0,0);

	return true;
}

void Update_Application3D(void)
{
	cdPlayer->PreUpdate();
	cdPlayer->PostUpdate();
	cdPlayer->Display();
}

void Shutdown_Application3D(void)
{
	if (cdPlayer)	{delete cdPlayer;	cdPlayer = NULL;	}
}